<?php

if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');

function softdelete_search() {
	$tpl =& $GLOBALS['templates']->cache['search_results_threads_inlinemoderation'];
	global $lang;
	$rpl = array('{$lang->approve_threads}' => '{$lang->approve_undelete_threads}');
	if($GLOBALS['mybb']->usergroup['cancp']) {
		$rpl['<option value="multideletethreads">{$lang->delete_threads}</option>'] = '<option value="multideletethreads">{$lang->delete_threads}</option><option value="do_multipurgethreads">{$lang->purge_threads}</option>';
		($lang->purge_threads) or $lang->purge_threads = 'Purge Deleted Threads';
	}
	($lang->approve_undelete_threads) or $lang->approve_undelete_threads = 'Approve/Undelete Threads';
	$tpl = strtr($tpl, $rpl);
	
	$tpl =& $GLOBALS['templates']->cache['search_results_posts_inlinemoderation'];
	$rpl = array('{$lang->inline_approve_posts}' => '{$lang->inline_approve_undelete_posts}');
	if($GLOBALS['mybb']->usergroup['cancp']) {
		$rpl['<option value="multideleteposts">{$lang->inline_delete_posts}</option>'] = '<option value="multideleteposts">{$lang->inline_delete_posts}</option><option value="do_multipurgeposts">{$lang->purge_posts}</option>';
		($lang->purge_posts) or $lang->purge_posts = 'Purge Deleted Posts';
	}
	($lang->inline_approve_undelete_posts) or $lang->inline_approve_undelete_posts = 'Approve/Undelete Posts';
	$tpl = strtr($tpl, $rpl);
	
	
	// hook in to fix pagination for individual threads
	if($GLOBALS['search']['resulttype'] == 'threads') {
		control_object($GLOBALS['db'], '
			function query($string, $hide_errors=0, $write_query=0) {
				static $done = false;
				if(!$done && strpos($string, "SELECT t.*, u.username AS userusername") && strpos($string, "LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=t.uid)")) {
					$done = true;
					$this->softdelete_search_intercept = true;
				}
				return parent::query($string, $hide_errors, $write_query);
			}
			function fetch_array($query) {
				if($this->softdelete_search_intercept) {
					$ret = parent::fetch_array($query);
					if($ret) {
						if($ret["deletedposts"]) {
							$ret["__softdelete_backup_unapprovedposts"] = $ret["unapprovedposts"];
							$ret["unapprovedposts"] += $ret["deletedposts"];
						}
					}
					else
						$this->softdelete_search_intercept = false;
					return $ret;
				}
				return parent::fetch_array($query);
			}
		');
		$GLOBALS['db']->softdelete_search_intercept = false;
	}
}


function softdelete_block_editpost() {
	global $mybb;
	$post = get_post(intval($mybb->input['pid']));
	if($post['pid']) {
		if($post['deleted'])
			error_no_permission();
		$thread = get_thread($post['tid']);
	}
	
	if($thread && $thread['deleted'])
		error_no_permission();
}
function softdelete_block_newreply() {
	if($GLOBALS['thread']['deleted'])
		error_no_permission();
}
function softdelete_block_editpoll() {
	global $pid, $mybb, $db;
	if(!$pid) $pid = intval($mybb->input['pid']);
	//$post = get_post($pid);
	$thread = $db->fetch_array($db->simple_select('threads', 'deleted', 'poll='.$pid));
	//if($post['pid']) $thread = get_thread($post['tid']);
	if($thread && $thread['deleted'])
		error_no_permission();
}
function softdelete_block_newpoll() {
	global $mybb;
	$thread = get_thread(intval($mybb->input['tid']));
	if($thread && $thread['deleted'])
		error_no_permission();
}
function softdelete_block_votepoll() {
	global $poll;
	if(!$poll['pid']) return;
	$thread = get_thread($poll['tid']);
	if($thread && $thread['deleted'])
		error_no_permission();
}
function softdelete_block_undovotepoll() {
	global $poll, $db, $mybb;
	$query = $db->simple_select("polls", "*", "pid='".intval($mybb->input['pid'])."'");
	$poll = $db->fetch_array($query);
	softdelete_block_votepoll();
}
function softdelete_block_ratethread() {
	global $thread;
	if($thread && $thread['deleted'])
		error_no_permission();
}



function softdelete_search_thread() {
	/*
	global $templates, $thread;
	static $started=false;
	
	// check for XThreads
	static $xthreads = null;
	if(!isset($xthreads))
		$xthreads = function_exists('xthreads_search_result');
	
	if($xthreads)
		$tplprefix = $GLOBALS['forumcache'][$thread['fid']]['xthreads_tplprefix'];
	
	if($thread['deleted']) {
		if(!$started) {
			if($xthreads) {
				$tplname = $tplprefix.'search_results_threads_thread_deleted';
				if($tplprefix && !isset($templates->cache[$tplname])) {
					$templates->cache($tplname);
					// if not found, prevent a duplicate query
					if(!isset($templates->cache[$tplname])) {
						$templates->cache[$tplname] = '';
					}
				}
				if($tplprefix && !$templates->cache[$tplname])
					$tplname = 'search_results_threads_thread_deleted';
				
				if(!$templates->cache[$tplname])
					$templates->cache($tplname);
				
				// if XThreads has made a backup template, use that
				if(isset($templates->cache['backup_search_results_threads_thread_backup__']))
					$templates->cache['__softdelete_backup_search_results_threads_thread'] =& $templates->cache['backup_search_results_threads_thread_backup__'];
				else
					$templates->cache['__softdelete_backup_search_results_threads_thread'] = $templates->cache['search_results_threads_thread'];
				$templates->cache['search_results_threads_thread'] =& $templates->cache[$tplname];
			} else {
				static $donecache = false;
				if(!$donecache) {
					$donecache = true;
					if(!$templates->cache['search_results_threads_thread'] || !$templates->cache['search_results_threads_thread_deleted'])
						$templates->cache('search_results_threads_thread,search_results_threads_thread_deleted');
					$templates->cache['__softdelete_backup_search_results_threads_thread'] = $templates->cache['search_results_threads_thread'];
				}
				$templates->cache['search_results_threads_thread'] =& $templates->cache['search_results_threads_thread_deleted'];
			}
			$started = true;
		}
		softdelete_delthread_setvars($thread['tid'], $thread['fid']);
	} elseif($started) {
		if($xthreads) {
			// if template prefix is used, XThreads will automatically revert the template for us
			if(!$tplprefix || !$templates->cache[$tplprefix.'search_results_threads_thread'])
				$templates->cache['search_results_threads_thread'] =& $templates->cache['__softdelete_backup_search_results_threads_thread'];
		}
		else
			$templates->cache['search_results_threads_thread'] =& $templates->cache['__softdelete_backup_search_results_threads_thread'];
		$started = false;
	} */
	
	global $thread;
	softdelete_search_tplhack($thread, 'thread');
	
	// counter fixup
	if($thread['deletedposts'] && isset($thread['__softdelete_backup_unapprovedposts']) && is_moderator($thread['fid'])) {
		// TODO: MyBB doesn't actually do this, but we have this code in preparation (but will probably need changing later when they do implement a fix for this issue)
		$thread['unapprovedposts'] = my_number_format($thread['__softdelete_backup_unapprovedposts']);
		unset($thread['__softdelete_backup_unapprovedposts']);
	}
}

function softdelete_search_post() {
	softdelete_search_tplhack($GLOBALS['post'], 'post');
}

function softdelete_search_tplhack(&$item, $what) {
	global $templates;
	static $started=false;
	
	// check for XThreads
	static $xthreads = null;
	if(!isset($xthreads))
		$xthreads = function_exists('xthreads_search_result');
	
	if($xthreads) {
		if(function_exists('xthreads_get_tplprefixes'))
			// newer version which supports conditionals
			$tplprefix = $GLOBALS['forum_tpl_prefixes'][$item['fid']];
		else
			list($tplprefix) = explode(',', $GLOBALS['forumcache'][$item['fid']]['xthreads_tplprefix']);
	}
	if(!$tplprefix && $tplprefix !== '0')
		$tplprefix = '';
	
	$tplbasename = 'search_results_'.$what.'s_'.$what;
	
	if($item['deleted'] && !$item['visible']) {
		if(!$started) {
			if($xthreads) {
				$tplname = $tplprefix.$tplbasename.'_deleted';
				if($tplprefix !== '' && !isset($templates->cache[$tplname])) {
					$templates->cache($tplname);
					// if not found, prevent a duplicate query
					if(!isset($templates->cache[$tplname])) {
						$templates->cache[$tplname] = '';
					}
				}
				if($tplprefix !== '' && !$templates->cache[$tplname])
					$tplname = $tplbasename.'_deleted';
				
				if(!$templates->cache[$tplname])
					$templates->cache($tplname);
				
				// if XThreads has made a backup template, use that
				if(isset($templates->cache['backup_'.$tplbasename.'_backup__']))
					$templates->cache['__softdelete_backup_'.$tplbasename] =& $templates->cache['backup_'.$tplbasename.'_backup__'];
				else
					$templates->cache['__softdelete_backup_'.$tplbasename] = $templates->cache[$tplbasename];
				$templates->cache[$tplbasename] =& $templates->cache[$tplname];
			} else {
				static $donecache = false;
				if(!$donecache) {
					$donecache = true;
					if(!$templates->cache[$tplbasename] || !$templates->cache[$tplbasename.'_deleted'])
						$templates->cache($tplbasename.','.$tplbasename.'_deleted');
					$templates->cache['__softdelete_backup_'.$tplbasename] = $templates->cache[$tplbasename];
				}
				$templates->cache[$tplbasename] =& $templates->cache[$tplbasename.'_deleted'];
			}
			$started = true;
		}
		softdelete_delthread_setvars($item[$what=='thread'?'tid':'pid'], $item['fid'], $what);
	} elseif($started) {
		if($xthreads) {
			// if template prefix is used, XThreads will automatically revert the template for us
			if($tplprefix === '' || !$templates->cache[$tplprefix.$tplbasename])
				$templates->cache[$tplbasename] =& $templates->cache['__softdelete_backup_'.$tplbasename];
		}
		else
			$templates->cache[$tplbasename] =& $templates->cache['__softdelete_backup_'.$tplbasename];
		$started = false;
	}
}
