<?php

if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');


function softdelete_modqueue_threads_db() {
	control_object($GLOBALS['db'], '
		function simple_select($table, $fields="*", $conditions="", $options=array()) {
			static $done=false;
			if(!$done && $table == "threads" && $fields == "COUNT(tid) AS unapprovedthreads" && substr($conditions, 0, 9) == "visible=0") {
				$done = true;
				$conditions .= " AND deleted=0";
			}
			return parent::simple_select($table, $fields, $conditions, $options);
		}
		function query($string, $hide_errors=0, $write_query=0) {
			static $done=false;
			if(!$done && strpos($string, "SELECT t.tid, t.dateline, t.fid, t.subject, p.message AS postmessage, u.username AS username, t.uid") && strpos($string, "WHERE t.visible=\'0\'")) {
				$done = true;
				$string = str_replace("WHERE t.visible=\'0\'", "WHERE t.visible=\'0\' AND t.deleted=0", $string);
			}
			return parent::query($string, $hide_errors, $write_query);
		}
	');
}
function softdelete_modqueue_posts_db($modcp) {
	control_object($GLOBALS['db'], '
		function query($string, $hide_errors=0, $write_query=0) {
			if(strpos($string, "WHERE p.visible=\'0\''.($modcp ? ' ".$GLOBALS["tflist"]."':'').' AND t.firstpost != p.pid")) {
				$string = str_replace("WHERE p.visible=\'0\'", "WHERE p.visible=\'0\' AND p.deleted=0", $string);
			}
			return parent::query($string, $hide_errors, $write_query);
		}
	');
}
function softdelete_modqueue_commit() {
	global $mybb, $db;
	if(is_array($mybb->input['threads'])) {
		control_object($db, '
			function simple_select($table, $fields="*", $conditions="", $options=array()) {
				static $done=false;
				if(!$done && $table == "threads" && $fields == "tid") {
					$done = true;
					$conditions .= " AND deleted=0";
				}
				return parent::simple_select($table, $fields, $conditions, $options);
			}
		');
	} elseif(is_array($mybb->input['posts'])) {
		control_object($db, '
			function simple_select($table, $fields="*", $conditions="", $options=array()) {
				static $done=false;
				if(!$done && $table == "posts" && $fields == "pid") {
					$done = true;
					$conditions .= " AND deleted=0";
				}
				return parent::simple_select($table, $fields, $conditions, $options);
			}
		');
	}
}

function softdelete_modcp() {
	global $mybb, $db;
	if($mybb->input['action'] == 'modqueue') {
		if(!$mybb->input['type'] || $mybb->input['type'] == 'threads') {
			softdelete_modqueue_threads_db();
		}
		if(!$mybb->input['type'] || $mybb->input['type'] == 'posts') {
			softdelete_modqueue_posts_db(true);
		}
	}
	
	if($mybb->input['action'] == 'do_modqueue') {
		softdelete_modqueue_commit();
	}
	
	if(!$mybb->input['action']) {
		// lazy - so copy code from above...
		control_object($db, '
			function query($string, $hide_errors=0, $write_query=0) {
				if(strpos($string, "WHERE p.visible=\'0\' ".$GLOBALS["tflist"]." AND t.firstpost != p.pid")) {
					$string = str_replace("WHERE p.visible=\'0\'", "WHERE p.visible=\'0\' AND p.deleted=0", $string);
				}
				return parent::query($string, $hide_errors, $write_query);
			}
			function simple_select($table, $fields="*", $conditions="", $options=array()) {
				if($table == "threads" && substr($conditions, 0, 9) == "visible=0" && ($fields == "COUNT(tid) AS unapprovedthreads" || $fields == "tid, subject, uid, username, dateline")) {
					$conditions .= " AND deleted=0";
				}
				return parent::simple_select($table, $fields, $conditions, $options);
			}
		');
	}
}

