<?php

// soft delete 1.0/1.1 -> 1.2 upgrader script

define('IN_MYBB', 1);
require './inc/init.php';

header('Content-Type: text/plain');

if(!$db->field_exists('deleted', 'threads')) die('Soft Delete plugin is not installed!');

if($db->field_exists('deletedposts', 'threads')) die('Soft Delete upgrade has already been applied.  Please delete this file (softdelete_upgrade.php) from the server.');

$db->write_query('ALTER TABLE '.$db->table_prefix.'threads ADD COLUMN `deletedposts` int(10) unsigned not null default 0');
$db->write_query('ALTER TABLE '.$db->table_prefix.'forums ADD COLUMN `deletedthreads` int(10) unsigned not null default 0');

// recount deleted post counts
@ignore_user_abort(true);
@set_time_limit(0);

$query = $db->simple_select('threads', 'fid,COUNT(tid) AS threads', 'deleted=1 GROUP BY fid');
while($f = $db->fetch_array($query)) {
	$db->write_query('UPDATE '.$db->table_prefix.'forums SET deletedthreads='.$f['threads'].' WHERE fid='.$f['fid']);
}
$db->free_result($query);

$query = $db->simple_select('posts', 'tid,COUNT(pid) AS posts', 'deleted=1 GROUP BY tid');
while($t = $db->fetch_array($query)) {
	$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts='.$t['posts'].' WHERE tid='.$t['tid']);
}
$db->free_result($query);



echo 'Soft Delete has successfully been upgraded.  Please delete this file (softdelete_upgrade.php) from your server.';
